extends TextureRect
###ReACT simple visual novel json.
export(String,FILE,"*.json") var diafile

var current_dialog = {}
var current_chapter = "start"
var current_page = 0

## AUDIO
func play_nar(aud):#Plays narration
	var audstream = load(aud)
	$audio.stream = audstream
	$audio.play()

## OPTIONS
func open_choice(chaplist):#List a bunch of paths the player can take
	$dialogchoice.clear()
	$dialogchoice.visible = true
	$dialog.visible = false
	for chap in chaplist:
		$dialogchoice.add_item(chap)

func close_choice(what):#Choose a dialog path
	$dialogchoice.visible = false
	$dialog.visible = true
	current_chapter = $dialogchoice.get_item_text(what)
	current_page = 0
	display_dialog(current_chapter,0)
	set_process_input(true)

## DIALOG
func start_dialog(dia,chap,pag=0):#Start dialog
	$dialogchoice.visible = false
	$dialog.visible = true
	set_process_input(true)
	load_json(dia)
	display_dialog(chap,pag)

func display_dialog(chap,pag):#Display text
	if(current_dialog.has(chap)):
		if(current_dialog[chap].size()>pag):
			match(typeof(current_dialog[chap][pag])):
				TYPE_ARRAY:
					$dialog.text = current_dialog[chap][pag][0]
					play_nar(current_dialog[chap][pag][1])
					texture = load(current_dialog[chap][pag][2])
					current_page+=1
				TYPE_DICTIONARY:
					open_choice(current_dialog[chap][pag].keys())
				TYPE_REAL:#Display an ending
					end_dialog()
					match(int(current_dialog[chap][pag])):
						0:#The cashless ending
							texture = load("res://assets/ending_cashless.png")
		else:
			end_dialog()
	else:
		end_dialog()

func end_dialog():
	$dialog.visible = false
	set_process_input(false)

func load_json(js):#Loads a json file
	var f = File.new()
	if(f.file_exists(js)):
		f.open(js,f.READ)
		var dat = JSON.parse(f.get_as_text())
		if(dat.error==OK):
			current_dialog = dat.result
		else:
			print_debug(dat.error_string," ",dat.error_line," in file ",js)
		f.close()

## MAIN
func _input(event):
	if(event.is_class("InputEventKey")):
		if(event.is_pressed()):
			display_dialog(current_chapter,current_page)

func _ready():
	start_dialog(diafile,"start")
	print_debug($audio.connect("finished",self,"display_dialog",[current_chapter,current_page]))
	print_debug($dialogchoice.connect("item_selected",self,"close_choice"))